<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>Framework: framework::core::Vector3D Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Framework
   </div>
   <div id="projectbrief">Framework drone</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classframework_1_1core_1_1_vector3_d.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Properties</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classframework_1_1core_1_1_vector3_d-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">framework::core::Vector3D Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class defining a 3D vector.  
 <a href="classframework_1_1core_1_1_vector3_d.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_vector3_d_8h_source.html">Vector3D.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for framework::core::Vector3D:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classframework_1_1core_1_1_vector3_d.png" usemap="#framework::core::Vector3D_map" alt=""/>
  <map id="framework::core::Vector3D_map" name="framework::core::Vector3D_map">
<area href="classframework_1_1core_1_1_vector3_ddata.html" title="Class defining a 3D vector and a io_data User must manually use the io_data&#39;s Mutex to access to Vect..." alt="framework::core::Vector3Ddata" shape="rect" coords="0,56,187,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab4dd9e802c4bb935353579d913f2c70d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#ab4dd9e802c4bb935353579d913f2c70d">Vector3D</a> (float <a class="el" href="classframework_1_1core_1_1_vector3_d.html#a4d3eb88d51b2ff4000fc93d1eb0a6f85">x</a>=0, float <a class="el" href="classframework_1_1core_1_1_vector3_d.html#a8b789cacf473b8ab1cde9a2a659ee9ab">y</a>=0, float <a class="el" href="classframework_1_1core_1_1_vector3_d.html#a003581dbd5bbf18e0a3dc5f31eba7f2a">z</a>=0)</td></tr>
<tr class="memdesc:ab4dd9e802c4bb935353579d913f2c70d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ab4dd9e802c4bb935353579d913f2c70d">More...</a><br /></td></tr>
<tr class="separator:ab4dd9e802c4bb935353579d913f2c70d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af14f36cbaf16bcef2642119d820a60b4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#af14f36cbaf16bcef2642119d820a60b4">~Vector3D</a> ()</td></tr>
<tr class="memdesc:af14f36cbaf16bcef2642119d820a60b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#af14f36cbaf16bcef2642119d820a60b4">More...</a><br /></td></tr>
<tr class="separator:af14f36cbaf16bcef2642119d820a60b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33e260779cc00eddc9c60555299b481f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a33e260779cc00eddc9c60555299b481f">RotateX</a> (float value)</td></tr>
<tr class="memdesc:a33e260779cc00eddc9c60555299b481f"><td class="mdescLeft">&#160;</td><td class="mdescRight">x axis rotation  <a href="#a33e260779cc00eddc9c60555299b481f">More...</a><br /></td></tr>
<tr class="separator:a33e260779cc00eddc9c60555299b481f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d17007ea3e5277d2e93052e79d7855a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a6d17007ea3e5277d2e93052e79d7855a">RotateXDeg</a> (float value)</td></tr>
<tr class="memdesc:a6d17007ea3e5277d2e93052e79d7855a"><td class="mdescLeft">&#160;</td><td class="mdescRight">x axis rotation  <a href="#a6d17007ea3e5277d2e93052e79d7855a">More...</a><br /></td></tr>
<tr class="separator:a6d17007ea3e5277d2e93052e79d7855a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab979d0250e1c5d97dff4e33daab08f04"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#ab979d0250e1c5d97dff4e33daab08f04">RotateY</a> (float value)</td></tr>
<tr class="memdesc:ab979d0250e1c5d97dff4e33daab08f04"><td class="mdescLeft">&#160;</td><td class="mdescRight">y axis rotation  <a href="#ab979d0250e1c5d97dff4e33daab08f04">More...</a><br /></td></tr>
<tr class="separator:ab979d0250e1c5d97dff4e33daab08f04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77f244217deb50de450444b984eabb48"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a77f244217deb50de450444b984eabb48">RotateYDeg</a> (float value)</td></tr>
<tr class="memdesc:a77f244217deb50de450444b984eabb48"><td class="mdescLeft">&#160;</td><td class="mdescRight">y axis rotation  <a href="#a77f244217deb50de450444b984eabb48">More...</a><br /></td></tr>
<tr class="separator:a77f244217deb50de450444b984eabb48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fe27062b8db045e2163a8193970c75f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a9fe27062b8db045e2163a8193970c75f">RotateZ</a> (float value)</td></tr>
<tr class="memdesc:a9fe27062b8db045e2163a8193970c75f"><td class="mdescLeft">&#160;</td><td class="mdescRight">z axis rotation  <a href="#a9fe27062b8db045e2163a8193970c75f">More...</a><br /></td></tr>
<tr class="separator:a9fe27062b8db045e2163a8193970c75f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f1f24be85e9a19b20f769f75caf687b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a6f1f24be85e9a19b20f769f75caf687b">RotateZDeg</a> (float value)</td></tr>
<tr class="memdesc:a6f1f24be85e9a19b20f769f75caf687b"><td class="mdescLeft">&#160;</td><td class="mdescRight">z axis rotation  <a href="#a6f1f24be85e9a19b20f769f75caf687b">More...</a><br /></td></tr>
<tr class="separator:a6f1f24be85e9a19b20f769f75caf687b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a03483b0253338c9b2fedba69a353c88c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a03483b0253338c9b2fedba69a353c88c">Rotate</a> (const <a class="el" href="classframework_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;matrix)</td></tr>
<tr class="memdesc:a03483b0253338c9b2fedba69a353c88c"><td class="mdescLeft">&#160;</td><td class="mdescRight">rotation  <a href="#a03483b0253338c9b2fedba69a353c88c">More...</a><br /></td></tr>
<tr class="separator:a03483b0253338c9b2fedba69a353c88c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa22e5d0d6f279148642bdd6e90608bad"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#aa22e5d0d6f279148642bdd6e90608bad">Rotate</a> (const <a class="el" href="classframework_1_1core_1_1_quaternion.html">Quaternion</a> &amp;quaternion)</td></tr>
<tr class="memdesc:aa22e5d0d6f279148642bdd6e90608bad"><td class="mdescLeft">&#160;</td><td class="mdescRight">rotation  <a href="#aa22e5d0d6f279148642bdd6e90608bad">More...</a><br /></td></tr>
<tr class="separator:aa22e5d0d6f279148642bdd6e90608bad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74ed38384bdcd5b27f430ce2fa5591cf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a74ed38384bdcd5b27f430ce2fa5591cf">To2Dxy</a> (<a class="el" href="classframework_1_1core_1_1_vector2_d.html">Vector2D</a> &amp;vector) const </td></tr>
<tr class="memdesc:a74ed38384bdcd5b27f430ce2fa5591cf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to a <a class="el" href="classframework_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>.  <a href="#a74ed38384bdcd5b27f430ce2fa5591cf">More...</a><br /></td></tr>
<tr class="separator:a74ed38384bdcd5b27f430ce2fa5591cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a363128dceaf3103ddb081ca81619bf4b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classframework_1_1core_1_1_vector2_d.html">Vector2D</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a363128dceaf3103ddb081ca81619bf4b">To2Dxy</a> (void) const </td></tr>
<tr class="memdesc:a363128dceaf3103ddb081ca81619bf4b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to a <a class="el" href="classframework_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>.  <a href="#a363128dceaf3103ddb081ca81619bf4b">More...</a><br /></td></tr>
<tr class="separator:a363128dceaf3103ddb081ca81619bf4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0db1d5dcdeb33260ee5f9ad20d1e8eac"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a0db1d5dcdeb33260ee5f9ad20d1e8eac">GetNorm</a> (void) const </td></tr>
<tr class="memdesc:a0db1d5dcdeb33260ee5f9ad20d1e8eac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Norm.  <a href="#a0db1d5dcdeb33260ee5f9ad20d1e8eac">More...</a><br /></td></tr>
<tr class="separator:a0db1d5dcdeb33260ee5f9ad20d1e8eac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf3965f4352fe2e6454a3c0597cbe2ec"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#aaf3965f4352fe2e6454a3c0597cbe2ec">Normalize</a> (void)</td></tr>
<tr class="memdesc:aaf3965f4352fe2e6454a3c0597cbe2ec"><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalize.  <a href="#aaf3965f4352fe2e6454a3c0597cbe2ec">More...</a><br /></td></tr>
<tr class="separator:aaf3965f4352fe2e6454a3c0597cbe2ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b44edb28e8757cebc90107999f1b6f5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a2b44edb28e8757cebc90107999f1b6f5">Saturate</a> (const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;min, const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;max)</td></tr>
<tr class="memdesc:a2b44edb28e8757cebc90107999f1b6f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a2b44edb28e8757cebc90107999f1b6f5">More...</a><br /></td></tr>
<tr class="separator:a2b44edb28e8757cebc90107999f1b6f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc84772470cf40f0831f69dfd07fbd61"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#afc84772470cf40f0831f69dfd07fbd61">Saturate</a> (float min, float max)</td></tr>
<tr class="memdesc:afc84772470cf40f0831f69dfd07fbd61"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#afc84772470cf40f0831f69dfd07fbd61">More...</a><br /></td></tr>
<tr class="separator:afc84772470cf40f0831f69dfd07fbd61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8725cca375d1fd28908e3320041e175e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a8725cca375d1fd28908e3320041e175e">Saturate</a> (const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;value)</td></tr>
<tr class="memdesc:a8725cca375d1fd28908e3320041e175e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a8725cca375d1fd28908e3320041e175e">More...</a><br /></td></tr>
<tr class="separator:a8725cca375d1fd28908e3320041e175e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ed597a9c4c4dc7cecb79fe619e659b1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a6ed597a9c4c4dc7cecb79fe619e659b1">Saturate</a> (float value)</td></tr>
<tr class="memdesc:a6ed597a9c4c4dc7cecb79fe619e659b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a6ed597a9c4c4dc7cecb79fe619e659b1">More...</a><br /></td></tr>
<tr class="separator:a6ed597a9c4c4dc7cecb79fe619e659b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af21cd2f0d3969024bc2c48058c252cf2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af21cd2f0d3969024bc2c48058c252cf2"></a>
float &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (size_t idx)</td></tr>
<tr class="separator:af21cd2f0d3969024bc2c48058c252cf2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a927d6a45d9524e4614608806d7d142b7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a927d6a45d9524e4614608806d7d142b7"></a>
const float &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (size_t idx) const </td></tr>
<tr class="separator:a927d6a45d9524e4614608806d7d142b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeabd1683d291b33940652bee8f052719"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aeabd1683d291b33940652bee8f052719"></a>
<a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;vector)</td></tr>
<tr class="separator:aeabd1683d291b33940652bee8f052719"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4a55a3cd60d905bb14c7d55334b46cf"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab4a55a3cd60d905bb14c7d55334b46cf"></a>
<a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator+=</b> (const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;vector)</td></tr>
<tr class="separator:ab4a55a3cd60d905bb14c7d55334b46cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e9a8280566ccc2e6ed8fba7f19f3775"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2e9a8280566ccc2e6ed8fba7f19f3775"></a>
<a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator-=</b> (const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;vector)</td></tr>
<tr class="separator:a2e9a8280566ccc2e6ed8fba7f19f3775"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a4d3eb88d51b2ff4000fc93d1eb0a6f85"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a4d3eb88d51b2ff4000fc93d1eb0a6f85">x</a></td></tr>
<tr class="memdesc:a4d3eb88d51b2ff4000fc93d1eb0a6f85"><td class="mdescLeft">&#160;</td><td class="mdescRight">x  <a href="#a4d3eb88d51b2ff4000fc93d1eb0a6f85">More...</a><br /></td></tr>
<tr class="separator:a4d3eb88d51b2ff4000fc93d1eb0a6f85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b789cacf473b8ab1cde9a2a659ee9ab"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a8b789cacf473b8ab1cde9a2a659ee9ab">y</a></td></tr>
<tr class="memdesc:a8b789cacf473b8ab1cde9a2a659ee9ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">y  <a href="#a8b789cacf473b8ab1cde9a2a659ee9ab">More...</a><br /></td></tr>
<tr class="separator:a8b789cacf473b8ab1cde9a2a659ee9ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a003581dbd5bbf18e0a3dc5f31eba7f2a"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_vector3_d.html#a003581dbd5bbf18e0a3dc5f31eba7f2a">z</a></td></tr>
<tr class="memdesc:a003581dbd5bbf18e0a3dc5f31eba7f2a"><td class="mdescLeft">&#160;</td><td class="mdescRight">z  <a href="#a003581dbd5bbf18e0a3dc5f31eba7f2a">More...</a><br /></td></tr>
<tr class="separator:a003581dbd5bbf18e0a3dc5f31eba7f2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class defining a 3D vector. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ab4dd9e802c4bb935353579d913f2c70d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">framework::core::Vector3D::Vector3D </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>x</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>y</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>z</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Construct a <a class="el" href="classframework_1_1core_1_1_vector3_d.html" title="Class defining a 3D vector. ">Vector3D</a> using specified values.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td></td></tr>
    <tr><td class="paramname">y</td><td></td></tr>
    <tr><td class="paramname">z</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af14f36cbaf16bcef2642119d820a60b4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">framework::core::Vector3D::~Vector3D </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a33e260779cc00eddc9c60555299b481f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::RotateX </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>x axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in radians </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6d17007ea3e5277d2e93052e79d7855a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::RotateXDeg </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>x axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in degrees </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab979d0250e1c5d97dff4e33daab08f04"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::RotateY </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>y axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in radians </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a77f244217deb50de450444b984eabb48"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::RotateYDeg </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>y axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in degrees </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9fe27062b8db045e2163a8193970c75f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::RotateZ </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>z axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in radians </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6f1f24be85e9a19b20f769f75caf687b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::RotateZDeg </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>z axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in degrees </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a03483b0253338c9b2fedba69a353c88c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Rotate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;&#160;</td>
          <td class="paramname"><em>matrix</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">matrix</td><td>rotation matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa22e5d0d6f279148642bdd6e90608bad"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Rotate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>quaternion</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>rotation </p>
<p>Compute a rotation from a quaternion. This method uses a rotation matrix internaly.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">quaternion</td><td>quaternion </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a74ed38384bdcd5b27f430ce2fa5591cf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::To2Dxy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classframework_1_1core_1_1_vector2_d.html">Vector2D</a> &amp;&#160;</td>
          <td class="paramname"><em>vector</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to a <a class="el" href="classframework_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>. </p>
<p>Uses x and y coordinates.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vector</td><td>destination </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a363128dceaf3103ddb081ca81619bf4b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classframework_1_1core_1_1_vector2_d.html">Vector2D</a> framework::core::Vector3D::To2Dxy </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to a <a class="el" href="classframework_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>. </p>
<p>Uses x and y coordinates.</p>
<dl class="section return"><dt>Returns</dt><dd>destination </dd></dl>

</div>
</div>
<a class="anchor" id="a0db1d5dcdeb33260ee5f9ad20d1e8eac"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float framework::core::Vector3D::GetNorm </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Norm. </p>
<dl class="section return"><dt>Returns</dt><dd>value </dd></dl>

</div>
</div>
<a class="anchor" id="aaf3965f4352fe2e6454a3c0597cbe2ec"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Normalize </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Normalize. </p>

</div>
</div>
<a class="anchor" id="a2b44edb28e8757cebc90107999f1b6f5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Saturate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;&#160;</td>
          <td class="paramname"><em>min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;&#160;</td>
          <td class="paramname"><em>max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between min and max</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">min</td><td>minimum value </td></tr>
    <tr><td class="paramname">max</td><td>maximum value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afc84772470cf40f0831f69dfd07fbd61"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Saturate </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between min and max</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">min</td><td>minimum Vector3D(min,min,min) value </td></tr>
    <tr><td class="paramname">max</td><td>maximum Vector3D(max,max,max) value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8725cca375d1fd28908e3320041e175e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Saturate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between -abs(value) and abs(value)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>saturation <a class="el" href="classframework_1_1core_1_1_vector3_d.html" title="Class defining a 3D vector. ">Vector3D</a> value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6ed597a9c4c4dc7cecb79fe619e659b1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Vector3D::Saturate </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between -abs(Vector3D(value,value,value)) and abs(Vector3D(value,value,value))</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>saturation Vector3D(value,value,value) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a4d3eb88d51b2ff4000fc93d1eb0a6f85"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float framework::core::Vector3D::x</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>x </p>

</div>
</div>
<a class="anchor" id="a8b789cacf473b8ab1cde9a2a659ee9ab"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float framework::core::Vector3D::y</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>y </p>

</div>
</div>
<a class="anchor" id="a003581dbd5bbf18e0a3dc5f31eba7f2a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float framework::core::Vector3D::z</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>z </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceframework.html">framework</a></li><li class="navelem"><a class="el" href="namespaceframework_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classframework_1_1core_1_1_vector3_d.html">Vector3D</a></li>
    <li class="footer">Generated on Tue Apr 12 2016 16:29:00 for Framework by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.7 </li>
  </ul>
</div>
</body>
</html>
